/*
 *  ,  2013 http://catcatcat.d-lan.dp.ua/
 * Gennady Chernov, Dnepropetrovsk 2013
 * I2C   V1.0.0
 *  PIC24HJ256GP206 I2C1
*/
//-------------------------------------------------------------------------
#include <xc.h>			//  
#include "i2c.h"
//----------------------------------------------------



//------------------------------------------------------------------------------
//   SSP  I2C   
void i2c_Open(unsigned int FCLOCK) //   100/400/1000 
{
#if I2Cselection

//    TRISF |= 0b0000000000001100; //      
    //    
    I2C1BRG = ((FCY / FCLOCK / 1000)-(FCY  / 10000000 + (FCY % 2 >= 5 ? 1 : 0))) - 1;
    if (I2C1BRG <= 2) I2C1BRG = 3; //        2

    I2C1CON = 0b1010001000000000;
    //		|||||||||||||||+-- SEN:
    //		||||||||||||||+--- RSEN:
    //		|||||||||||||+---- PEN:
    //		||||||||||||+----- RCEN:
    //		|||||||||||+------ ACKEN:
    //		||||||||||+------- ACKDT:
    //		|||||||||+-------- STREN:      (  )
    //		||||||||+--------- GCEN:     (  )    
    //		|||||||+---------- SMEN:    SMBus 
    //		||||||+----------- DISSLW:      
    //		|||||+------------ A10M:     (  )
    //		||||+------------- IPMIEN: 0  
    //		|||+-------------- SCLREL:     (  )
    //		||+--------------- I2CSIDL: 1 -     
    //		|+----------------  
    //		+----------------- I2CEN:  I2C ,    

    while (I2C1STATbits.TRSTAT); //   
    I2C1CONbits.PEN = 1; //   
    while (I2C1CONbits.PEN); //     

#else
//    TRISG |= 0b0000000110000000; //      
    //    
    I2C2BRG = ((((FCY / 2) / FCLOCK) / 1000)-((FCY / 2) / 10000000 + (FCY % 2 >= 5 ? 1 : 0))) - 1;
    if (I2C2BRG <= 2) I2C2BRG = 3; //        2

    I2C2CON = 0b1010001000000000;
    //		|||||||||||||||+-- SEN:
    //		||||||||||||||+--- RSEN:
    //		|||||||||||||+---- PEN:
    //		||||||||||||+----- RCEN:
    //		|||||||||||+------ ACKEN:
    //		||||||||||+------- ACKDT:
    //		|||||||||+-------- STREN:      (  )
    //		||||||||+--------- GCEN:     (  )    
    //		|||||||+---------- SMEN:    SMBus 
    //		||||||+----------- DISSLW:      
    //		|||||+------------ A10M:     (  )
    //		||||+------------- IPMIEN: 0  
    //		|||+-------------- SCLREL:     (  )
    //		||+--------------- I2CSIDL: 1 -     
    //		|+----------------  
    //		+----------------- I2CEN:  I2C ,    

    while (I2C2STATbits.TRSTAT); //   
    I2C2CONbits.PEN = 1; //   
    while (I2C2CONbits.PEN); //     

#endif
}//

//------------------------------------------------------------------------------
void i2c_stop(void)//  
{
#if I2Cselection
    while (I2C1STATbits.TRSTAT);        //   
    I2C1CONbits.PEN = 1;                //   
    while (I2C1CONbits.PEN);            //     
#else
    while (I2C2STATbits.TRSTAT);        //   
    I2C2CONbits.PEN = 1;                //   
    while (I2C2CONbits.PEN);            //     
#endif
}//


//------------------------------------------------------------------------------
unsigned char i2c_start(unsigned char adres, unsigned char R_W)//   START  
{
#if I2Cselection
    //       
    while (I2C1STATbits.TRSTAT); //   

    I2C1CONbits.SEN = 1;
    while (I2C1CONbits.SEN);

    if (R_W == 0) adres &= 0b11111110; // R_W
    else adres |= 0b00000001; //

    I2C1TRN = adres;
    while (I2C1STATbits.TBF);       //   

    if (I2C1STATbits.ACKSTAT == 0) return 0; //  
    else {
        i2c_stop();                 //  
        return 1;                   //  , 
    }
#else
    //       
    while (I2C2STATbits.TRSTAT); //   

    I2C2CONbits.SEN = 1;
    while (I2C2CONbits.SEN);

    if (R_W == 0) adres &= 0b11111110; // R_W
    else adres |= 0b00000001;       //

    I2C2TRN = adres;
    while (I2C2STATbits.TBF);       //   

    if (I2C2STATbits.ACKSTAT == 0) return 0; //  
    else {
        i2c_stop();                 //  
        return 1;                   //  , 
    }
#endif

}

//------------------------------------------------------------------------------
unsigned char i2c_restart(unsigned char adres, unsigned char R_W)//   START  
{
#if I2Cselection
    //       
    while (I2C1STATbits.TRSTAT); //   

    I2C1CONbits.RSEN = 1;
    while (I2C1CONbits.RSEN);

    if (R_W == 0) adres &= 0b11111110; // R_W
    else adres |= 0b00000001; //

    I2C1TRN = adres;
    while (I2C1STATbits.TBF);       //   

    if (I2C1STATbits.ACKSTAT == 0) return 0; //  
    else {
        i2c_stop();                 //  
        return 1;                   //  , 
    }
#else
    //       
    while (I2C2STATbits.TRSTAT); //   

    I2C2CONbits.SEN = 1;
    while (I2C2CONbits.SEN);

    if (R_W == 0) adres &= 0b11111110; // R_W
    else adres |= 0b00000001;       //

    I2C2TRN = adres;
    while (I2C2STATbits.TBF);       //   

    if (I2C2STATbits.ACKSTAT == 0) return 0; //  
    else {
        i2c_stop();                 //  
        return 1;                   //  , 
    }
#endif

}

//------------------------------------------------------------------------------

unsigned char i2c_write(unsigned char data) //	;     
{
#if I2Cselection
    while (I2C1STATbits.TRSTAT);     //   
    I2C1TRN = data;
    while (I2C1STATbits.TBF);       //   
    if (I2C1STATbits.ACKSTAT == 0) return 0; //  
    else {
        i2c_stop();                 //  
        return 1;                   //  , 
    }
#else
    while (I2C2STATbits.TRSTAT);    //   
    I2C2TRN = data;
    while (I2C2STATbits.TBF);       //   
    if (I2C2STATbits.ACKSTAT == 0) return 0; //  
    else {
        i2c_stop();                 //  
        return 1;                   //  , 
    }
#endif

}//

//------------------------------------------------------------------------------

unsigned char i2c_read_ack(void)    //       
{
#if I2Cselection

    while (I2C1STATbits.TRSTAT);    //   

    I2C1CONbits.RCEN = 1;           //  
    Nop();
    //	while (I2C2CONbits.RCEN);
    //	while (I2C2STATbits.TRSTAT);//   
    while (!I2C1STATbits.RBF);      //    

    I2C1CONbits.ACKDT = 0;          //   
    I2C1CONbits.ACKEN = 1;          //  
    while (I2C1CONbits.ACKEN);      //  

    return I2C1RCV;                 // 
#else

    while (I2C2STATbits.TRSTAT);    //   

    I2C2CONbits.RCEN = 1;           //  
    Nop();
    //	while (I2C2CONbits.RCEN);
    //	while (I2C2STATbits.TRSTAT);//   
    while (!I2C2STATbits.RBF);      //    

    I2C2CONbits.ACKDT = 0;          //   
    I2C2CONbits.ACKEN = 1;          //  
    while (I2C2CONbits.ACKEN);      //  

    return I2C2RCV;                 // 
#endif

}//

//------------------------------------------------------------------------------

unsigned char i2c_read_noack(void)  //       _ 
{
#if I2Cselection
    while (I2C1STATbits.TRSTAT);    //   

    I2C1CONbits.RCEN = 1;           //  
    Nop();
    //	while (I2C2CONbits.RCEN);
    //	while (I2C2STATbits.TRSTAT);
    while (!I2C1STATbits.RBF);      //    

    I2C1CONbits.ACKDT = 1;          //  - 
    I2C1CONbits.ACKEN = 1;          //  
    while (I2C1CONbits.ACKEN);      //  
    I2C1CONbits.ACKDT = 0;          //Set for NotACk

    return I2C1RCV;                 // 
#else
    while (I2C2STATbits.TRSTAT);    //   

    I2C2CONbits.RCEN = 1;           //  
    Nop();
    //	while (I2C2CONbits.RCEN);
    //	while (I2C2STATbits.TRSTAT);
    while (!I2C2STATbits.RBF);      //    

    I2C2CONbits.ACKDT = 1;          //  - 
    I2C2CONbits.ACKEN = 1;          //  
    while (I2C2CONbits.ACKEN);      //  
    I2C2CONbits.ACKDT = 0;          //Set for NotACk

    return I2C2RCV;                 // 
#endif

}//

//------------------------------------------------------------------------------


